osgParticle::RadialShooter Class Reference

`#include <RadialShooter>`

Inheritance diagram for osgParticle::RadialShooter:

## Public Member Functions

| RadialShooter ()
| RadialShooter (const RadialShooter &copy, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgParticle, RadialShooter)
const rangef & | getThetaRange () const
| Get the range of possible values for theta angle.
void | setThetaRange (const rangef &r)
| Set the range of possible values for theta angle.
void | setThetaRange (float r1, float r2)
| Set the range of possible values for theta angle.
const rangef & | getPhiRange () const
| Get the range of possible values for phi angle.
void | setPhiRange (const rangef &r)
| Set the range of possible values for phi angle.
void | setPhiRange (float r1, float r2)
| Set the range of possible values for phi angle.
const rangef & | getInitialSpeedRange () const
| Get the range of possible values for initial speed of particles.
void | setInitialSpeedRange (const rangef &r)
| Set the range of possible values for initial speed of particles.
void | setInitialSpeedRange (float r1, float r2)
| Set the range of possible values for initial speed of particles.
const rangev3 & | getInitialRotationalSpeedRange () const
| Get the range of possible values for initial rotational speed of particles.
void | setInitialRotationalSpeedRange (const rangev3 &r)
| Set the range of possible values for initial rotational speed of particles.
void | setInitialRotationalSpeedRange (const osg::Vec3 &r1, const osg::Vec3 &r2)
| Set the range of possible values for initial rotational speed of particles.
void | shoot (Particle *P) const
| Shoot a particle. Do not call this method manually.
Public Member Functions inherited from osgParticle::Shooter
| Shooter ()
| Shooter (const Shooter &copy, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
virtual const char * | libraryName () const
virtual const char * | className () const
virtual bool | isSameKindAs (const osg::Object *obj) const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~RadialShooter ()
RadialShooter & | operator= (const RadialShooter &)
Protected Member Functions inherited from osgParticle::Shooter
virtual | ~Shooter ()
Shooter & | operator= (const Shooter &)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Detailed Description

A shooter class that shoots particles radially. This shooter computes the velocity vector of incoming particles by choosing a random direction and a random speed. Both direction and speed are chosen within specified ranges. The direction is defined by two angles: theta, which is the angle between the velocity vector and the Z axis, and phi, which is the angle between the X axis and the velocity vector projected onto the X-Y plane.

## Constructor & Destructor Documentation

## RadialShooter() [1/2]

osgParticle::RadialShooter::RadialShooter | ( |  | ) |

inline

References osgParticle::Shooter::Shooter().

Referenced by META_Object(), operator=(), and RadialShooter().

## RadialShooter() [2/2]

osgParticle::RadialShooter::RadialShooter | ( | const RadialShooter & | copy,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

inline

References RadialShooter(), and osgParticle::Shooter::Shooter().

## ~RadialShooter()

virtual osgParticle::RadialShooter::~RadialShooter | ( |  | ) |

inline protected virtual

## Member Function Documentation

## getInitialRotationalSpeedRange()

const rangev3 & osgParticle::RadialShooter::getInitialRotationalSpeedRange | ( |  | ) | const

inline

Get the range of possible values for initial rotational speed of particles.

## getInitialSpeedRange()

const rangef & osgParticle::RadialShooter::getInitialSpeedRange | ( |  | ) | const

inline

Get the range of possible values for initial speed of particles.

## getPhiRange()

const rangef & osgParticle::RadialShooter::getPhiRange | ( |  | ) | const

inline

Get the range of possible values for phi angle.

## getThetaRange()

const rangef & osgParticle::RadialShooter::getThetaRange | ( |  | ) | const

inline

Get the range of possible values for theta angle.

## META_Object()

osgParticle::RadialShooter::META_Object | ( | osgParticle | ,
|  | RadialShooter | )

References RadialShooter().

## operator=()

RadialShooter & osgParticle::RadialShooter::operator= | ( | const RadialShooter & |  | ) |

inline protected

References RadialShooter().

## setInitialRotationalSpeedRange() [1/2]

void osgParticle::RadialShooter::setInitialRotationalSpeedRange | ( | const osg::Vec3 & | r1,
|  | const osg::Vec3 & | r2 )

inline

Set the range of possible values for initial rotational speed of particles.

References osgParticle::range< ValueType >::minimum.

## setInitialRotationalSpeedRange() [2/2]

void osgParticle::RadialShooter::setInitialRotationalSpeedRange | ( | const rangev3 & | r | ) |

inline

Set the range of possible values for initial rotational speed of particles.

## setInitialSpeedRange() [1/2]

void osgParticle::RadialShooter::setInitialSpeedRange | ( | const rangef & | r | ) |

inline

Set the range of possible values for initial speed of particles.

## setInitialSpeedRange() [2/2]

void osgParticle::RadialShooter::setInitialSpeedRange | ( | float | r1,
|  | float | r2 )

inline

Set the range of possible values for initial speed of particles.

References osgParticle::range< ValueType >::minimum.

## setPhiRange() [1/2]

void osgParticle::RadialShooter::setPhiRange | ( | const rangef & | r | ) |

inline

Set the range of possible values for phi angle.

## setPhiRange() [2/2]

void osgParticle::RadialShooter::setPhiRange | ( | float | r1,
|  | float | r2 )

inline

Set the range of possible values for phi angle.

References osgParticle::range< ValueType >::minimum.

## setThetaRange() [1/2]

void osgParticle::RadialShooter::setThetaRange | ( | const rangef & | r | ) |

inline

Set the range of possible values for theta angle.

## setThetaRange() [2/2]

void osgParticle::RadialShooter::setThetaRange | ( | float | r1,
|  | float | r2 )

inline

Set the range of possible values for theta angle.

References osgParticle::range< ValueType >::minimum.

## shoot()

void osgParticle::RadialShooter::shoot | ( | Particle * | P | ) | const

inline virtual

Shoot a particle. Do not call this method manually.

Implements osgParticle::Shooter.

References osgParticle::Particle::setAngularVelocity(), and osgParticle::Particle::setVelocity().

The documentation for this class was generated from the following file:

- RadialShooter